#include <AT89x52.H>
#include "MyType.h"
#include "PDIUSBD12.H"
#include "config.h"
#include "UART.h"

/********************************************************************
ܣD12д
ڲCommandһֽ
    أޡ
    עޡ
********************************************************************/
void D12WriteCommand(uint8 Command)
{
 D12SetCommandAddr();  //Ϊַ
 D12ClrWr(); //WRõ
 D12SetPortOut(); //ݿΪ״̬עΪպֲ꣬ʱã
 D12SetData(Command);  //ݿ
 D12SetWr(); //WRø
 D12SetPortIn(); //ݿΪ״̬Աʹ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣһֽD12ݡ
ڲޡ
    أصһֽڡ
    עޡ
********************************************************************/
uint8 D12ReadByte(void)
{
 uint8 temp;
 D12SetDataAddr(); //Ϊݵַ
 D12ClrRd(); //RDõ
 temp=D12GetData(); //
 D12SetRd(); //RDø
 return temp; //ض
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣD12ID
ڲޡ
    أD12ID
    עޡ
********************************************************************/
uint16 D12ReadID(void)
{
 uint16 id;
 D12WriteCommand(Read_ID); //дID
 id=D12ReadByte(); //IDŵֽ
 id|=((uint16)D12ReadByte())<<8; //IDŸֽ
 return id;
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣдһֽD12ݡ
ڲValueҪдһֽݡ
    أޡ
    עޡ
********************************************************************/
void D12WriteByte(uint8 Value)
{
 D12SetDataAddr(); //Ϊݵַ
 D12ClrWr(); //WRõ
 D12SetPortOut(); //ݿΪ״̬עΪպֲ꣬ʱã
 D12SetData(Value); //д
 D12SetWr(); //WRø
 D12SetPortIn(); //ݿΪ״̬Աʹ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣȡD12״̬Ĵĺ
ڲEndp˵š
    أ˵״̬
    עòö˵жϱ־λ
********************************************************************/
uint8 D12ReadEndpointLastStatus(uint8 Endp)
{
 D12WriteCommand(0x40+Endp); //ȡ˵״̬
 return D12ReadByte();
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣѡ˵ĺѡһ˵ܶݲ
ڲEndp˵š
    أޡ
    עޡ
********************************************************************/
void D12SelectEndpoint(uint8 Endp)
{
 D12WriteCommand(0x00+Endp); //ѡ˵
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣն˵㻺ĺ
ڲޡ
    أޡ
    עֻʹøú˵㻺󣬸ýն˵ܽµݰ
********************************************************************/
void D12ClearBuffer(void)
{
 D12WriteCommand(D12_CLEAR_BUFFER);
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣӦĺ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void D12AcknowledgeSetup(void)
{
 D12SelectEndpoint(1); //ѡ˵0
 D12WriteCommand(D12_ACKNOWLEDGE_SETUP); //Ӧõ˵0
 D12SelectEndpoint(0); //ѡ˵0
 D12WriteCommand(D12_ACKNOWLEDGE_SETUP); //Ӧõ˵0
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣȡ˵㻺
ڲEndp˵ţLenҪȡĳȣBufݵĻ
    أʵʶݳȡ
    עޡ
********************************************************************/
uint8 D12ReadEndpointBuffer(uint8 Endp, uint8 Len, uint8 *Buf)
{
 uint8 i,j;
 D12SelectEndpoint(Endp); //ѡҪĶ˵㻺
 D12WriteCommand(D12_READ_BUFFER); //Ͷ
 D12ReadByte();   //ֽǱģá
 j=D12ReadByte(); //ʵʵĽյݳ
 if(j>Len) //Ҫֽʵʽյݳ
 {
  j=Len;  //ָֻĳ
 }
#ifdef DEBUG1 //DEBUG1ҪʾϢ
#ifdef DEBUG3
 Prints("˵");
 PrintLongInt(Endp/2); //˵šD12Ķ˵֯ʽ
                       //01ֱʾ˵0룻
                       //23ֱʾ˵1룻
                       //34ֱʾ˵2롣
                       //Ҫ2ʾӦĶ˵㡣
 Prints("");
 PrintLongInt(j);      //ʵʶȡֽ
 Prints("ֽڡ\r\n");
#endif
#endif
 for(i=0;i<j;i++)
 {
  //ﲻֱӵöһֽڵĺֱģʱ򣬿Խʡʱ
  D12ClrRd();  //RDõ
  *(Buf+i)=D12GetData(); //һֽ
  D12SetRd();  //RDø
#ifdef DEBUG1
#ifdef DEBUG3
  PrintHex(*(Buf+i)); //ҪʾϢʾ
  if(((i+1)%16)==0)Prints("\r\n"); //ÿ16ֽڻһ
#endif
#endif
 }
#ifdef DEBUG1
#ifdef DEBUG3
 if((j%16)!=0)Prints("\r\n"); //
#endif
#endif
 return j; //ʵʶȡֽ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣʹܷͶ˵㻺Чĺ
ڲޡ
    أޡ
    עֻʹøúʹܷͶ˵Ч֮ݲܷͳȥ
********************************************************************/
void D12ValidateBuffer(void)
{
 D12WriteCommand(D12_VALIDATE_BUFFER);
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣд˵㻺
ڲEndp˵ţLenҪ͵ĳȣBufݵĻ
    أLenֵ
    עޡ
********************************************************************/
uint8 D12WriteEndpointBuffer(uint8 Endp,uint8 Len,uint8 * Buf)
{
 uint8 i;
 D12SelectEndpoint(Endp); //ѡ˵
 D12WriteCommand(D12_WRITE_BUFFER); //дWrite Buffer
 D12WriteByte(0); //ֽڱд0
 D12WriteByte(Len);  //дҪݵĳ
 
#ifdef DEBUG1 //DEBUG1ҪʾϢ
 Prints("д˵");
 PrintLongInt(Endp/2); //˵šD12Ķ˵֯ʽ
                       //01ֱʾ˵0룻
                       //23ֱʾ˵1룻
                       //34ֱʾ˵2롣
                       //Ҫ2ʾӦĶ˵㡣
 Prints("");
 PrintLongInt(Len);    //дֽ
 Prints("ֽڡ\r\n");
#endif
 D12SetPortOut(); //ݿΪ״̬עΪպֲ꣬ʱã
 for(i=0;i<Len;i++)
 {
  //ﲻֱӵдһֽڵĺֱģʱ򣬿Խʡʱ
  D12ClrWr(); //WRõ  
  D12SetData(*(Buf+i)); //ݷŵ
  D12SetWr();  //WRøߣһֽд
#ifdef DEBUG0
#ifdef DEBUG3 //ZivDebug
  PrintHex(*(Buf+i));  //ҪʾϢʾ͵
  if(((i+1)%16)==0)Prints("\r\n"); //ÿ16ֽڻһ
#endif
#endif  //ZivDebug
 }


#ifdef DEBUG0
#ifdef DEBUG3
  if((Len%16)!=0)Prints("\r\n"); //
#endif
#endif
 D12SetPortIn(); //ݿл״̬
 D12ValidateBuffer(); //ʹ˵Ч
 return Len; //Len
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣõַ
ڲAddrҪõĵֵַ
    أޡ
    עޡ
********************************************************************/
void D12SetAddress(uint8 Addr)
{
 D12WriteCommand(D12_SET_ADDRESS_ENABLE); //дõַ
 D12WriteByte(0x80 | Addr); //дһֽݣʹַܼ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣʹܶ˵㺯
ڲEnable: Ƿʹܡ0ֵΪʹܣ0ֵΪʹܡ
    أޡ
    עޡ
********************************************************************/
void D12SetEndpointEnable(uint8 Enable)
{
 D12WriteCommand(D12_SET_ENDPOINT_ENABLE);
 if(Enable!=0)
 {
  D12WriteByte(0x01); //D0Ϊ1ʹܶ˵
 }
 else
 {
  D12WriteByte(0x00); //ʹܶ˵
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣȡD12˵״̬
ڲEndp˵š
    أ˵״̬Ĵֵ
    עޡ
********************************************************************/
uint8 D12ReadEndpointStatus(uint8 Endp)
{
 D12WriteCommand(0x80+Endp); //ȡ˵״̬
 return D12ReadByte();
}
////////////////////////End of function//////////////////////////////