#ifndef __PDIUSBD12_H__
#define __PDIUSBD12_H__

#include <at89x52.h>
#include "MyType.h"

//ַݵַ
#define D12_COMMAND_ADD           1
#define D12_DATA_ADD              0

//PDIUSBD12оƬ
#define D12_DATA                  P0
#define D12_A0                    P3_5
#define D12_WR                    P3_6
#define D12_RD                    P3_7
#define D12_INT                   P3_2

//ѡݵַ
#define D12SetCommandAddr() D12_A0=D12_COMMAND_ADD
#define D12SetDataAddr()    D12_A0=D12_DATA_ADD
//WR
#define D12SetWr() D12_WR=1
#define D12ClrWr() D12_WR=0
//RD
#define D12SetRd() D12_RD=1
#define D12ClrRd() D12_RD=0
//ȡжŵƽ״̬
#define D12GetIntPin()  D12_INT
//д
#define D12GetData() D12_DATA
#define D12SetData(Value) D12_DATA=(Value)

//ݿΪ״̬51Ƭ˿д1Ϊ״̬
#define D12SetPortIn() D12_DATA=0xFF

//ݿΪ״̬51Ƭ׼˫IOڣԲлΪպ
#define D12SetPortOut()

//D12ĶID
#define Read_ID  0xFD

//D12ģʽ
#define D12_SET_MODE  0xF3

//D12ĶжϼĴ
#define READ_INTERRUPT_REGISTER  0xF4

//D12˵㻺
#define D12_READ_BUFFER 0xF0

//D12д˵㻺
#define D12_WRITE_BUFFER 0xF0

//D12ն˵㻺
#define D12_CLEAR_BUFFER    0xF2

//D12ʹܷͶ˵㻺
#define D12_VALIDATE_BUFFER 0xFA

//D12Ӧð
#define D12_ACKNOWLEDGE_SETUP 0xF1

//D12õַ/ʹ
#define D12_SET_ADDRESS_ENABLE 0xD0

//D12ʹܶ˵
#define D12_SET_ENDPOINT_ENABLE 0xD8

//
void D12WriteCommand(uint8);
uint8 D12ReadByte(void);
uint16 D12ReadID(void);
void D12WriteByte(uint8);
void DelayXms(uint16);
uint8 D12ReadEndpointBuffer(uint8 Endp, uint8 Len, uint8 *Buf);
uint8 D12WriteEndpointBuffer(uint8 Endp, uint8 Len, uint8 *Buf);
void D12ClearBuffer(void);
uint8 D12ReadEndpointLastStatus(uint8 Endp);
void D12AcknowledgeSetup(void);
void D12SetAddress(uint8 Addr);
void D12SetEndpointEnable(uint8 Enable);
uint8 D12ReadEndpointStatus(uint8 Endp);

#endif
