#include <at89x52.H>

#include "UART.h"
#include "MyType.h"
#include "config.h"


volatile uint8 Sending;


/********************************************************************
ܣڳʼ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void InitUART(void)
{
 EA=0; //ʱرж
 TMOD&=0x0F;  //ʱ1ģʽڸ4λ
 TMOD|=0x20;    //ʱ1ģʽ2Զװģʽ
 SCON=0x50;     //ڹģʽ1
 TH1=256-Fclk/(BitRate*12*16);  //㶨ʱװֵ
 TL1=256-Fclk/(BitRate*12*16);
 PCON|=0x80;    //ڲʼӱ
 ES=1;         //ж
 TR1=1;        //ʱ1
 REN=1;        // 
 EA=1;         //ж
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣжϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UartISR(void) interrupt 4
{
 if(RI)    //յ
 {
  RI=0;   //ж
 }
 else      //һֽ
 {
  TI=0;
  Sending=0;  //ڷͱ־
 }
}
////////////////////////End of function//////////////////////////////

#ifdef DEBUG0

/********************************************************************
ܣתʮַ͡
ڲxʾ
    أޡ
    עޡ
********************************************************************/
void PrintLongInt(uint32 x)
{
 int8 i;
 uint8 display_buffer[10];

 for(i=9;i>=0;i--)
 {
  display_buffer[i]='0'+x%10;
  x/=10;
 }
 for(i=0;i<9;i++)
 {
  if(display_buffer[i]!='0')break;
 }
 for(;i<10;i++)UartPutChar(display_buffer[i]);
}
////////////////////////End of function//////////////////////////////

#endif

#if (defined DEBUG0)

code uint8 HexTable[]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

/********************************************************************
ܣһbyteݡ
ڲ͵ݡ
    أޡ
    עޡ
********************************************************************/
void Printc(uint8 x)
{
 Sending=1;
 SBUF=x;
 while(Sending);
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣHEXʽһbyteݡ
ڲ͵
    أޡ
    עޡ
********************************************************************/
void PrintHex(uint8 x)
{
 Printc('0');
 Printc('x');
 Printc(HexTable[x>>4]);
 Printc(HexTable[x&0xf]);
 Printc(' ');
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣһַ
ڲpdҪ͵ַָ롣
    أޡ
    עޡ
********************************************************************/
void Prints(uint8 * pd)
{
 while((*pd)!='\0') //ֱַ0Ž
 {
  UartPutChar(*pd); //һַ
  pd++;  //ƶһַ
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣڷһֽݡ
ڲd: Ҫ͵ֽݡ
    أޡ
    עޡ
********************************************************************/
void UartPutChar(uint8 d)
{
 SBUF=d; //д뵽ڻ
 Sending=1;	 //÷ͱ־
 while(Sending); //ȴ
}
////////////////////////End of function//////////////////////////////
#endif

#ifdef DEBUG0
/********************************************************************
ܣʮƷ͡
ڲ͵
    أޡ
    עޡ
********************************************************************/
void PrintShortIntHex(uint16 x)
{
 uint8 i;
 uint8 display_buffer[7];
 display_buffer[6]=0;
 display_buffer[0]='0';
 display_buffer[1]='x';
 for(i=5;i>=2;i--) //תΪ4ֽڵHEXֵ
 {
  display_buffer[i]=HexTable[(x&0xf)];
  x>>=4;
 }
 Prints(display_buffer);
}
////////////////////////End of function//////////////////////////////

#endif