#include "config.h"
#include "pdiusbd12.h"
#include "uart.h"
#include "usbcore.h"
#include "led.h"
#include "SCSI.h"


idata uint8 Buffer[16];  //˵0õĻ

idata uint8 CBW[31];  //CBWõĻ
idata uint8 CSW[13];  //CSWõĻ

//USB豸ĸֶ
uint8  bmRequestType;
uint8  bRequest;
uint16 wValue;
uint16 wIndex;
uint16 wLength;
//ǰݵλ
uint8 * pSendData;
//Ҫݵĳ
uint16 SendLength;
//ǷҪ0ݰı־USBƴݹУ
//صݰֽʱΪݹ̽
//ֽʵҪصֽʵʷصֽ
//ָպǶ˵0СʱҪһ0ȵݰ
//ݹ̡һ־ǷҪ
//һ0ȵݰ
uint8 NeedZeroPacket;

//ǰֵֻ÷0ú
uint8 ConfigValue;

//˵1Ƿæı־ʱñ־Ϊ档
//пʱñ־Ϊ١
uint8 Ep1InIsBusy;
uint8 Ep2InIsBusy;

//߼Ԫʵһ߼ԪֵΪ0
//ڶԺУ߼ԪֶΣ
//0ĳ1߼ԪӶʾ
//ȫһĴ̡ĳnͻʾn+1ȫһĴ̡
//16߼Ԫn=15
code uint8 MaxLun[1]={0};

//Ľ׶Σ(COMMAND_STAGE)(DATA_STAGE)״̬(STATUS_STAGE)
uint8 TransportStage;

//USB豸Ķ
code uint8 DeviceDescriptor[0x12]=  //豸Ϊ18ֽ
{
//bLengthֶΡ豸ĳΪ18(0x12)ֽ
 0x12,
 
//bDescriptorTypeֶΡ豸ıΪ0x01
 0x01,
 
//bcdUSBֶΡð汾ΪUSB1.10x0110
//С˽ṹԵֽȣ0x100x01
 0x10,
 0x01,
 
//bDeviceClassֶΡǲ豸ж豸࣬
//ڽӿж豸࣬ԸֶεֵΪ0
 0x00,
 
//bDeviceSubClassֶΡbDeviceClassֶΪ0ʱֶҲΪ0
 0x00,
 
//bDeviceProtocolֶΡbDeviceClassֶΪ0ʱֶҲΪ0
 0x00,
 
//bMaxPacketSize0ֶΡPDIUSBD12Ķ˵0С16ֽڡ
 0x10,
 
//idVenderֶΡIDţȡ0x8888ʵá
//ʵʲƷʹóIDţUSBЭ볧IDš
//עСģʽֽȡ
 0x88,
 0x89,
 
//idProductֶΡƷIDţǵھŸʵ飬ȡ0x0009
//עСģʽֽӦǰ
 0x09,
 0x00,
 
//bcdDeviceֶΡUSB̸տʼͽ1.0ɣ0x0100
//Сģʽֽȡ
 0x00,
 0x01,
 
//iManufacturerֶΡֵַΪ˷͹
//ַʹ1ʼɡ
 0x01,

//iProductֶΡƷֵַո1ȡ2ɡ
//עֵַҪʹֵͬ
 0x02,
 
//iSerialNumberֶΡ豸кֵַ
//ȡ3Ϳˡ
 0x03,

//bNumConfigurationsֶΡ豸е
//ֻҪһþˣ˸ֵΪ1
 0x01
};
//////////////////////////豸//////////////////////////////

//USBϵĶ
//ܳΪ9+9+9+7+7ֽ
code uint8 ConfigurationDescriptor[9+9+7+7]=
{
 /**************************************/
 //bLengthֶΡĳΪ9ֽڡ
 0x09,
 
 //bDescriptorTypeֶΡΪ0x02
 0x02,
 
 //wTotalLengthֶΡϵܳȣ
 //ӿ˵ȡ
 sizeof(ConfigurationDescriptor)&0xFF, //ֽ
 (sizeof(ConfigurationDescriptor)>>8)&0xFF, //ֽ
 
 //bNumInterfacesֶΡðĽӿ1ӿڡ
 0x01,
 
 //bConfigurationֶΡõֵΪ1
 0x01,
 
 //iConfigurationzֶΣõַûУΪ0
 0x00,
 
 //bmAttributesֶΣ豸ԡǵİ߹ģ
 //ǲʵԶ̻ѵĹܣԸֶεֵΪ0x80
 0x80,
 
 //bMaxPowerֶΣ豸Ҫǵİ
 //Ҫĵ100mAΪ100mAÿλ
 //Ϊ2mAΪ50(0x32)
 0x32,
 
 /*****************ӿ*******************/
 //bLengthֶΡӿĳΪ9ֽڡ
 0x09,
 
 //bDescriptorTypeֶΡӿıΪ0x04
 0x04,
 
 //bInterfaceNumberֶΡýӿڵıţһӿڣΪ0
 0x00,
 
 //bAlternateSettingֶΡýӿڵıñţΪ0
 0x00,
 
 //bNumEndpointsֶΡ0˵Ŀýӿ2˵
 0x02,
 
 //bInterfaceClassֶΡýӿʹõࡣ洢豸ӿĴΪ0x08
 0x08,
 
 //bInterfaceSubClassֶΡýӿʹõࡣSCSI͸Ϊ0x06
 0x05,
 
 //bInterfaceProtocolֶΡЭΪ䣬Ϊ0x50
 0x50,
 
 //iConfigurationֶΡýӿڵֵַûУΪ0
 0x00,
  
 /*************׼˵****************/
 //bLengthֶΡ˵Ϊ7ֽڡ
 0x07,
 
 //bDescriptorTypeֶΡ˵Ϊ0x05
 0x05,
 
 //bEndpointAddressֶΡ˵ĵַʹD12˵2
 //D7λʾݷ˵D7Ϊ1˵2ĵַΪ0x82
 0x82,
 
 //bmAttributesֶΡD1~D0Ϊ˵㴫ѡ
 //ö˵Ϊ˵㡣˵ıΪ2λΪ0
 0x02,
 
 //wMaxPacketSizeֶΡö˵˵2Ϊ64ֽڡ
 //עֽȡ
 0x40,
 0x00,
 
 //bIntervalֶΡ˵ѯʱ䣬˴塣
 0x00,
 
 /*************׼˵****************/
 //bLengthֶΡ˵Ϊ7ֽڡ
 0x07,
 
 //bDescriptorTypeֶΡ˵Ϊ0x05
 0x05,
 
 //bEndpointAddressֶΡ˵ĵַʹD12˵2
 //D7λʾݷ˵D7Ϊ0˵2ĵַΪ0x02
 0x02,
 
 //bmAttributesֶΡD1~D0Ϊ˵㴫ѡ
 //ö˵Ϊ˵㡣˵ıΪ2λΪ0
 0x02,
 
 //wMaxPacketSizeֶΡö˵˵2Ϊ64ֽڡ
 //עֽȡ
 0x40,
 0x00,
 
 //bIntervalֶΡ˵ѯʱ䣬˴塣
 0x00
};
//////////////////////////////////////////////////

/************************IDĶ********************/
code uint8 LanguageId[4]=
{
 0x04, //ĳ
 0x03, //ַ
 //0x0409ΪʽӢID
 0x09,
 0x04
};
////////////////////////ID//////////////////////////////////

/**************************************************/
/*********        ת         **********/
/********* Http://computer00.21ic.org    **********/
/*********        : ȦȦ         **********/
/*********         ӭʹ          **********/
/*********    ȨУд   **********/
/**************************************************/

//http://computer00.21ic.org/user1/2198/archives/2007/42769.html
//ַȦȦUSBר Http://group.ednchina.com/93/Unicode
//8λС˸ʽ
code uint8 ManufacturerStringDescriptor[82]={
82,         //ĳΪ82ֽ
0x03,       //ַͱΪ0x03
0x35, 0x75, //
0x11, 0x81, //
0x08, 0x57, //Ȧ
0x08, 0x57, //Ȧ
0x84, 0x76, //
0x55, 0x00, //U
0x53, 0x00, //S
0x42, 0x00, //B
0x13, 0x4e, //ר
0x3a, 0x53, //
0x20, 0x00, // 
0x48, 0x00, //H
0x74, 0x00, //t
0x74, 0x00, //t
0x70, 0x00, //p
0x3a, 0x00, //:
0x2f, 0x00, ///
0x2f, 0x00, ///
0x67, 0x00, //g
0x72, 0x00, //r
0x6f, 0x00, //o
0x75, 0x00, //u
0x70, 0x00, //p
0x2e, 0x00, //.
0x65, 0x00, //e
0x64, 0x00, //d
0x6e, 0x00, //n
0x63, 0x00, //c
0x68, 0x00, //h
0x69, 0x00, //i
0x6e, 0x00, //n
0x61, 0x00, //a
0x2e, 0x00, //.
0x63, 0x00, //c
0x6f, 0x00, //o
0x6d, 0x00, //m
0x2f, 0x00, ///
0x39, 0x00, //9
0x33, 0x00, //3
0x2f, 0x00  ///
};
/////////////////////////ַ/////////////////////////////

//ַȦȦUSB֮ U̡Unicode
//8λС˸ʽ
code uint8 ProductStringDescriptor[32]={
32,         //ĳΪ32ֽ
0x03,       //ַͱΪ0x03
0x0a, 0x30, //
0x08, 0x57, //Ȧ
0x08, 0x57, //Ȧ
0x59, 0x65, //
0x60, 0x4f, //
0xa9, 0x73, //
0x55, 0x00, //U
0x53, 0x00, //S
0x42, 0x00, //B
0x0b, 0x30, //
0x4b, 0x4e, //֮
0x20, 0x00, // 
0x47, 0x50, //
0x55, 0x00, //U
0xd8, 0x76, //
};
////////////////////////Ʒַ////////////////////////////

//ַ2008-08-14Unicode
//8λС˸ʽ
code uint8 SerialNumberStringDescriptor[22]={
22,         //ĳΪ22ֽ
0x03,       //ַͱΪ0x03
0x32, 0x00, //2
0x30, 0x00, //0
0x30, 0x00, //0
0x38, 0x00, //8
0x2d, 0x00, //-
0x30, 0x00, //0
0x38, 0x00, //8
0x2d, 0x00, //-
0x31, 0x00, //1
0x34, 0x00  //4
};
//////////////////////Ʒкַ/////////////////////////

/********************************************************************
ܣʱx뺯
ڲxʱĺ
    أޡ
    עޡ
********************************************************************/
void DelayXms(uint16 x)                
{
 uint16 i;
 uint16 j;
 for(i=0;i<x;i++)
 for(j=0;j<227;j++); //ѭʱ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣUSBϿӺ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbDisconnect(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("ϿUSBӡ\r\n");
#endif
#endif

 D12WriteCommand(D12_SET_MODE);  //дģʽ
 D12WriteByte(0x06); //ģʽĵһֽ
 D12WriteByte(0x47); //ģʽĵڶֽ
 DelayXms(1000);  //ӳ1
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣUSBӺ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbConnect(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB\r\n");
#endif
#endif
 D12WriteCommand(D12_SET_MODE);  //дģʽ
 D12WriteByte(0x16); //ģʽĵһֽ
 D12WriteByte(0x47); //ģʽĵڶֽ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ߹жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbBusSuspend(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB߹\r\n");
#endif
#endif
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ߸λжϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbBusReset(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB߸λ\r\n");
#endif
#endif
 Ep1InIsBusy=0; //λ˵1뻺С
 Ep2InIsBusy=0; //λ˵2뻺С
 TransportStage=COMMAND_STAGE; //λ׶Ϊ׶Ρ
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣpDataSendLengthݷ͵˵0ĺ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp0SendData(void)
{
 //д˵ȥ׼
 //д֮ǰҪжһҪ͵Ƿȶ˵0
 //󳤶ȴ˵Сһֻܷ
 //ݡ˵0DeviceDescriptor[7]
 if(SendLength>DeviceDescriptor[7])
 {
  //ȷ
  D12WriteEndpointBuffer(1,DeviceDescriptor[7],pSendData);
  //ͺʣֽ
  SendLength-=DeviceDescriptor[7];
  //һκָλҪ
  pSendData+= DeviceDescriptor[7];
 }
 else
 {
  if(SendLength!=0)
  {
   //ֱӷ
   D12WriteEndpointBuffer(1,SendLength,pSendData);
   //ϺSendLengthȱΪ0
   SendLength=0;
  }
  else //Ҫ͵ݰΪ0
  {
   if(NeedZeroPacket==1) //Ҫ0
   {
    D12WriteEndpointBuffer(1,0,pSendData); //0ݰ
    NeedZeroPacket=0; //Ҫ0ݰ־
   }
  }
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ˵0жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp0Out(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB˵0жϡ\r\n");
#endif
#endif

 //ȡ˵0״̬òжϱ־
 //жϵ5λǷΪ1ǣ˵ǽ
 if(D12ReadEndpointLastStatus(0)&0x20)
 {
  D12ReadEndpointBuffer(0,16,Buffer); //
  D12AcknowledgeSetup(); //Ӧ
  D12ClearBuffer(); //建
  //豸ĸֶ
  bmRequestType=Buffer[0];
  bRequest=Buffer[1];
  wValue=Buffer[2]+(((uint16)Buffer[3])<<8);
  wIndex=Buffer[4]+(((uint16)Buffer[5])<<8);
  wLength=Buffer[6]+(((uint16)Buffer[7])<<8);
  //ĴжϾ󣬲ݲͬز
  //D7λΪ1˵
  if((bmRequestType&0x80)==0x80)
  {
   //bmRequestTypeD6~5λɢתD6~5λʾ
   //0Ϊ׼1Ϊ2Ϊ
   switch((bmRequestType>>5)&0x03)
   {
    case 0:  //׼
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("USB׼");
     #endif
	 #endif
     //USBЭ鶨˼׼ʵЩ׼󼴿
     //ĴbRequestУԲͬɢת
     //ʵϣǻҪԽ߽ɢתΪͬ
     //ǲһġbmRequestTypeD4~D0λж塣
     //Ϊ˼򻯲Щʡ˶Խߵжϡ
     //ȡֻ
     switch(bRequest)
     {
      case GET_CONFIGURATION: //ȡ
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ȡá\r\n");
       #endif
	   #endif
      break;
      
      case GET_DESCRIPTOR:  //ȡ
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ȡ");
       #endif
	   #endif
       //ͽɢתȫ豸
       //׼ַֻ֧͵豸豸áַ
       switch((wValue>>8)&0xFF)
        {
         case DEVICE_DESCRIPTOR: //豸
          #ifdef DEBUG0
		  #ifdef DEBUG3
           Prints("豸\r\n");
          #endif
		  #endif
          pSendData=DeviceDescriptor;  //Ҫ͵
          //жֽǷʵҪ͵ֽ
          //豸ݳȾ
          //DeviceDescriptor[0]ıʵʵĳ
          //ôֻʵʳȵ
          if(wLength>DeviceDescriptor[0])
          {
           SendLength=DeviceDescriptor[0];
           if(SendLength%DeviceDescriptor[7]==0) //Ҹպݰʱ
           {
            NeedZeroPacket=1; //Ҫ0ȵݰ
           }
          }
          else
          {
           SendLength=wLength;
          }
          //ͨEP0
          UsbEp0SendData();
         break;
         
         case CONFIGURATION_DESCRIPTOR:  //
          #ifdef DEBUG0
		  #ifdef DEBGU3
           Prints("\r\n");
          #endif
		  #endif
          pSendData=ConfigurationDescriptor; //Ҫ͵Ϊ
          //жֽǷʵҪ͵ֽ
          //ϣݳȾ
          //ConfigurationDescriptor[3]*256+ConfigurationDescriptor[2]
          //ıʵʵĳôֻʵʳȵ
          SendLength=ConfigurationDescriptor[3];
          SendLength=SendLength*256+ConfigurationDescriptor[2];
          if(wLength>SendLength)
          {
           if(SendLength%DeviceDescriptor[7]==0) //Ҹպݰʱ
           {
            NeedZeroPacket=1; //Ҫ0ȵݰ
           }
          }
          else
          {
           SendLength=wLength;
          }
          //ͨEP0
          UsbEp0SendData();
         break;
         
         case STRING_DESCRIPTOR:  //ַ
          #ifdef DEBUG0
		  #ifdef DEBUG3
           Prints("ַ");
          #endif
		  #endif
          switch(wValue&0xFF)  //wValueĵֽڣֵɢת
          {
           case 0:  //ȡID
            #ifdef DEBUG0
			#ifdef DEBUG3
             Prints("(ID)\r\n");
            #endif
			#endif
            pSendData=LanguageId;
            SendLength=LanguageId[0];
           break;
           
           case 1:  //ֵַΪ1Ϊַ
           #ifdef DEBUG0
		   #ifdef DEBUG3
             Prints("()\r\n");
           #endif
		   #endif
            pSendData=ManufacturerStringDescriptor;
            SendLength=ManufacturerStringDescriptor[0];
           break;
           
           case 2:  //ƷֵַΪ2ΪƷַ
           #ifdef DEBUG0
		   #ifdef DEBUG3
             Prints("(Ʒ)\r\n");
            #endif
			#endif
            pSendData=ProductStringDescriptor;
            SendLength=ProductStringDescriptor[0];
           break;
           
           case 3:  //ƷкŵֵΪ3Ϊк
           #ifdef DEBUG0
		   #ifdef DEBUG3
             Prints("(Ʒк)\r\n");
            #endif
			#endif
            pSendData=SerialNumberStringDescriptor;
            SendLength=SerialNumberStringDescriptor[0];
           break;
           
           default :
            #ifdef DEBUG0
			#ifdef DEBUG3
             Prints("(δֵ֪)\r\n");
            #endif
			#endif
            //δֵ֪󣬷һ0ȵİ
            SendLength=0;
            NeedZeroPacket=1;
           break;
          }
          //жֽǷʵҪ͵ֽ
          //ıʵʵĳôֻʵʳȵ
          if(wLength>SendLength)
          {
           if(SendLength%DeviceDescriptor[7]==0) //Ҹպݰʱ
           {
            NeedZeroPacket=1; //Ҫ0ȵݰ
           }
          }
          else
          {
           SendLength=wLength;
          }
          //ͨEP0
          UsbEp0SendData();         
         break;

         case REPORT_DESCRIPTOR:  //
          #ifdef DEBUG0
		  #ifdef DEBUG3
           Prints("\r\n");
          #endif
		  #endif
         break;
                 
         default:  //
          #ifdef DEBUG0
		  #ifdef DEBUG3
           Prints("룺");
           PrintHex((wValue>>8)&0xFF);
           Prints("\r\n");
          #endif
		  #endif
         break;
        }
       break;
      
      case GET_INTERFACE: //ȡӿ
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ȡӿڡ\r\n");
       #endif
	   #endif
      break;
      
      case GET_STATUS: //ȡ״̬
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ȡ״̬\r\n");
       #endif
	   #endif
      break;
      
      case SYNCH_FRAME: //ͬ֡
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ͬ֡\r\n");
       #endif
	   #endif
      break;
      
      default:  //δı׼
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("δı׼\r\n");
       #endif   
	   #endif    
      break;
     }
    break;
    
    case 1:  //
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("USB");
     #endif
	 #endif
     switch(bRequest)
     {
      case GET_MAX_LUN: //ΪGET_MAX_LUN(0xFE)
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ȡ߼Ԫ\r\n");
       #endif
	   #endif
       
       pSendData=MaxLun; //Ҫصλ
       SendLength=1;     //Ϊ1ֽ
       //ĳȱʵʳȶ̣󳤶
       if(wLength<SendLength) 
       {
        SendLength=wLength;
       }
       //ͨEP0
       UsbEp0SendData();
      break;
      
      default:
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("δ֪\r\n");
       #endif
	   #endif
      break;
     }
    break;
    
    case 2:  //
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("USB\r\n");
     #endif
	 #endif
    break;
    
    default: //δֻʾһϢ
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("δ\r\n");
     #endif
	 #endif
    break;
   }
  }
  //˵
  else //if(bmRequestType&0x80==0x80)֮else
  {
   //bmRequestTypeD6~5λɢתD6~5λʾ
   //0Ϊ׼1Ϊ2Ϊ
   switch((bmRequestType>>5)&0x03)
   {
    case 0:  //׼
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("USB׼");
     #endif
	 #endif
     //USBЭ鶨˼׼ʵЩ׼󼴿
     //ĴbRequestУԲͬɢת
     switch(bRequest)
     {
      case CLEAR_FEATURE: //
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ԡ\r\n");
       #endif
	   #endif
      break;
      
      case SET_ADDRESS:  //õַ
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("õַַΪ");
        PrintHex(wValue&0xFF); //ʾõĵַ
        Prints("\r\n");
       #endif
	   #endif
       D12SetAddress(wValue&0xFF); //wValueеĵֽõĵֵַ
       //õַûݹֱ̣ӽ뵽״̬̣һ0ȵݰ
       SendLength=0;
       NeedZeroPacket=1;
       //ͨEP0
       UsbEp0SendData();
      break;
      
      case SET_CONFIGURATION: //
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("á\r\n");
       #endif
	   #endif
       //ʹܷ0˵㡣0˵ֻΪ0úʹܡ
       //wValueĵֽΪõֵֵΪ0ʹܷ0˵㡣
       //浱ǰֵ
       ConfigValue=wValue&0xFF;
       D12SetEndpointEnable(ConfigValue);
       //һ0ȵ״̬ݰ
       SendLength=0;
       NeedZeroPacket=1;
       //ͨEP0
       UsbEp0SendData();
      break;
      
      case SET_DESCRIPTOR: //
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("\r\n");
       #endif
	   #endif
      break;
      
      case SET_FEATURE: //
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ԡ\r\n");
       #endif
	   #endif
      break;

      case SET_INTERFACE: //ýӿ
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("ýӿڡ\r\n");
       #endif
	   #endif
       //һ0ȵ״̬ݰ
       SendLength=0;
       NeedZeroPacket=1;
       //ͨEP0
       UsbEp0SendData();
      break;
      
      default:  //δı׼
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("δı׼\r\n");
       #endif  
	   #endif     
      break;
     }
    break;
    
    case 1:  //
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("USB");
     #endif
	 #endif
     switch(bRequest)
     {
      case MASS_STORAGE_RESET:
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("洢豸λ\r\n");
       #endif
	   #endif
       
       //Ϊ׶(CBW)
       TransportStage=COMMAND_STAGE;
       //һ0ȵݰ
       SendLength=0;
       NeedZeroPacket=1;
       //ͨEP0
       UsbEp0SendData();
      break;
      
      default:
       #ifdef DEBUG0
	   #ifdef DEBUG3
        Prints("δ֪\r\n");
       #endif
	   #endif
      break;
     }
    break;
    
    case 2:  //
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("USB\r\n");
     #endif
	 #endif
    break;
    
    default: //δֻʾһϢ
     #ifdef DEBUG0
	 #ifdef DEBUG3
      Prints("δ\r\n");
     #endif
	 #endif
    break;
   }
  }
 }
 //ͨ
 else //if(D12ReadEndpointLastStatus(0)&0x20)֮else
 {
  D12ReadEndpointBuffer(0,16,Buffer);
  D12ClearBuffer();
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ˵0жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp0In(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB˵0жϡ\r\n");
#endif
#endif
 //״̬⽫˵0жϱ־λ
 D12ReadEndpointLastStatus(1);
 //ʣֽ
 UsbEp0SendData();
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ˵1жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp1Out(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB˵1жϡ\r\n");
#endif
#endif
 //˵״̬⽫˵1жϱ־λ
 D12ReadEndpointLastStatus(2);
 //˵㻺
 D12ClearBuffer();
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ˵1жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp1In(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB˵1жϡ\r\n");
#endif
#endif
 //״̬⽫˵1жϱ־λ
 D12ReadEndpointLastStatus(3);
 //˵1봦ڿ״̬
 Ep1InIsBusy=0;
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ˵2жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp2Out(void)
{
 uint8 Len;
 
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB˵2жϡ\r\n");
#endif
#endif

 //˫ûȫʱжϱ־
 if((D12ReadEndpointStatus(4)&0x60)!=0x60)
 {
  //״̬⽫˵2жϱ־λ
  D12ReadEndpointLastStatus(4);
 }
 if(TransportStage==COMMAND_STAGE)
 {
  //ݶصCBW
  Len=D12ReadEndpointBuffer(4,sizeof(CBW),CBW);
  //˵㻺
  D12ClearBuffer();
  if(Len==31) //յݳ31ֽڣ˵CBW
  {
   //CBWǩǷȷǩΪUSBC
   if((CBW[0]=='U')&&(CBW[1]=='S')&&(CBW[2]=='B')&&(CBW[3]=='C'))
   {
    //CBWǩȷSCSI
    ProcScsiCommand();
   }
  }
 }
 else if(TransportStage==DATA_STAGE)
 {
   ProcScsiOutData(); //SCSI
 }
 else 
 {
  D12ReadEndpointBuffer(4,0,0);
  D12ClearBuffer();
 }
}
////////////////////////End of function//////////////////////////////

/********************************************************************
ܣ˵2жϴ
ڲޡ
    أޡ
    עޡ
********************************************************************/
void UsbEp2In(void)
{
#ifdef DEBUG0
#ifdef DEBUG3
 Prints("USB˵2жϡ\r\n");
#endif
#endif
 //״̬⽫˵2жϱ־λ
 D12ReadEndpointLastStatus(5);
 Ep2SendData();  //
 //˫ûжд
 if((D12ReadEndpointStatus(5)&0x06)!=0x06)
 {
  Ep2SendData(); //ٷһݣ˫
 }
}
////////////////////////End of function//////////////////////////////
